#! /bin/bash
# write out to a file and error to different one
LOG="install.log"
LOG_IN_USER=$(who | awk 'NR==1{print $1;}')
exec 3>&1

exec > "$LOG" 2> >(tee -a "$LOG" >&2)

echo "Update" >&3
sudo apt-get update -y
# install all programms from the install.list
echo "Installing install.list" >&3
cat install.list | xargs sudo apt-get -y install
# uninstal all programms from the list
echo "Uninstalling uninstall.list" >&3
cat uninstall.list | xargs sudo apt-get -y purge
# download additional packages 
echo "Downloading extra packages from Download.list" >&3
cat download.list | xargs sudo wget -nv
# install the packages
clear
echo "Installing all .deb files" >&3
sudo apt-get install -y ./*.deb
# set up flatpack
echo "Setting up flatpack" >&3
flatpak remote-add --if-not-exists flathub https://dl.flathub.org/repo/flathub.flatpakrepo 
# install languages by ISO 639-1 short
echo "Installing additional languages" >&3
for l in en uk ru ar; do
	sudo apt-get -y install $(check-language-support -l $l)
done

# clean the system
echo "Update, Upgrade and cleaning" >&3
sudo apt-get update -y
sudo apt-get full-upgrade -y
sudo apt-get clean -y 

#set nomacs as default
echo "setting default programs" >&3
FILE="/usr/share/applications/mimeinfo.cache"
FILETYPES="org.nomacs.ImageLounge.desktop;XnView.desktop;gimp.desktop;simple-image-reducer.desktop;"
for type in png jpg jpeg gif; do
	sudo sed -i "s|^\(image/${type}=\).*|\1${FILETYPES}|" "$FILE"
done
# copy content of desktop_files to desktop
DESKTOP_PATH=$(xdg-user-dir DESKTOP)

sudo -u csr cp -r desktop_files/. /home/csr/Schreibtisch/

# import panel settings from file TO DO
#echo "setting up desktop UI" >&3
#sudo -u csr xfce4-panel-profiles load ./default_panel.tar.bz2

# set up firefox
echo "Install UBlock"
firefox https://addons.mozilla.org/de/firefox/addon/ublock-origin/ & disown
read -p "Continue with Enter"

echo "Set default Browser, Start page & Search engine"
firefox about:preferences & disown
read -p "Continue with Enter"

echo "If panel is not imported do 'xfce4-panel-profiles load ./default_panel.tar.bz2' in a seperate window"
read -p "Continue with Enter"

# create skel for new user UI
echo "Setting up skel" >&3
sudo mkdir /etc/skel/Schreibtisch
sudo mkdir /etc/skel/.config
sudo mkdir /etc/skel/.local
sudo cp -r /home/csr/.config/* /etc/skel/.config/
sudo cp -r /home/csr/.local/* /etc/skel/.local/
sudo cp -r /home/csr/Schreibtisch/* /etc/skel/Schreibtisch/

sudo chown -R root:root /etc/skel

read -n 1 -s -r -p "Fertig, schließen mit Tastendruck" >&3